%define anolis_release 2
%define abidir %{_prefix}/lib/compatibility/%{name}

Name:		smartmontools	
Version:	7.3
Release:	%{anolis_release}%{?dist}
Summary:	http://smartmontools.sourceforge.net/

License:	GPLv2+
URL:		http://smartmontools.sourceforge.net/
Source0:	https://sourceforge.net/projects/smartmontools/files/smartmontools/7.3/%{name}-%{version}.tar.gz
Source1:	smartmontools.sysconf
Source2:	smartdnotify
# https://sourceforge.net/p/smartmontools/code/HEAD/tree/trunk/smartmontools/drivedb.h?format=raw%20Source5:drivedb.h
Source3:	drivedb.h

BuildRequires:	make
BuildRequires:	gcc-c++ readline-devel ncurses-devel automake util-linux groff gettext
BuildRequires:	libselinux-devel libcap-ng-devel
BuildRequires:	systemd systemd-devel

%description
The smartmontools package contains two utility programs (smartctl
and smartd) to control and monitor storage systems using the Self-
Monitoring, Analysis and Reporting Technology System (SMART) built
into most modern ATA and SCSI hard disks. In many cases, these
utilities will provide advanced warning of disk degradation and
failure.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -n %{name}-%{version} -p1
cp %{SOURCE3} ./

%build
autoreconf -i
%configure \
	--with-selinux \
	--with-libcap-ng=yes \
	--with-libsystemd \
	--with-systemdsystemunitdir=%{_unitdir} \
	--sysconfdir=%{_sysconfdir}/%{name}/ \
	--with-systemdenvfile=%{_sysconfdir}/sysconfig/%{name}

# update SOURCE5 on maintainer's machine prior commiting, there's no internet connection on builders
%make_build update-smart-drivedb
./update-smart-drivedb -s - -u sf drivedb.h ||:
cp drivedb.h ../drivedb.h ||:

%make_build CXXFLAGS="$RPM_OPT_FLAGS -fpie" LDFLAGS="-pie -Wl,-z,relro,-z,now"

%install
%make_install

rm -f examplescripts/Makefile*
chmod a-x -R examplescripts/*
install -D -p -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/smartmontools
install -D -p -m 755 %{SOURCE2} $RPM_BUILD_ROOT/%{_libexecdir}/%{name}/smartdnotify
mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/%{name}/smartd_warning.d
rm -rf $RPM_BUILD_ROOT/etc/{rc.d,init.d}
rm -rf $RPM_BUILD_ROOT%{_docdir}/%{name}
mkdir -p $RPM_BUILD_ROOT%{_sharedstatedir}/%{name}

export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:%{buildroot}/%{_libdir}
mkdir -p %{buildroot}/%{abidir}
pushd %{buildroot}/%{abidir}
for dir in %{_sbindir} %{_bindir} ; do
        for f in $(ls %{buildroot}/$dir) ; do
                full_name=%{buildroot}/$dir/$f
                (file $full_name | grep executable > /dev/null 2>&1 && $full_name --help > $f-option.list > /dev/null 2>&1) || echo "ok"
        done
done

%preun
%systemd_preun smartd.service

%post
%systemd_post smartd.service

%postun
%systemd_postun_with_restart smartd.service

%files
%license COPYING
%doc examplescripts smartd.conf
%dir %{_sysconfdir}/%name
%dir %{_sysconfdir}/%name/smartd_warning.d
%config(noreplace) %{_sysconfdir}/%{name}/smartd.conf
%config(noreplace) %{_sysconfdir}/%{name}/smartd_warning.sh
%config(noreplace) %{_sysconfdir}/sysconfig/smartmontools
%{_unitdir}/smartd.service
%{_sbindir}/smartd
%{abidir}/smartd-option.list
%{_sbindir}/update-smart-drivedb
%{abidir}/update-smart-drivedb-option.list
%{_sbindir}/smartctl
%{abidir}/smartctl-option.list
%{_mandir}/man?/smart*.*
%{_mandir}/man?/update-smart*.*
%{_libexecdir}/%{name}
%{_datadir}/%{name}
%{_sharedstatedir}/%{name}

%files doc
%doc AUTHORS ChangeLog INSTALL NEWS README TODO

%changelog
* Thu Oct 13 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 7.3-2
- add api & add doc package

* Mon Apr 18 2022 happy_orange <songnannan@linux.alibaba.com> - 7.3-1
- Init package from upstream
